*USER SUBROUTINE
      SUBROUTINE DFLUX(FLUX,SOL,KSTEP,KINC,TIME,NOEL,NPT,COORDS,
     1 JLTYP,TEMP,PRESS,SNAME)
      include 'ABA_PARAM.INC'
      DIMENSION  FLUX(2),TIME(2),COORDS(3)

      REAL SOL,TEMP,PRESS
      INTEGER JSTEP,JINC,NOEL,NPT,JLTYP
      CHARACTER*80 SNAME
      REAL t,dt,x,y,z
      REAL FLUX1,FLUX2,FLUX3
*times
      t=time(1)
      dt=time(2)
!      WRITE(6,*)'t=',t
!      WRITE(6,*)'dt=',dt
      
*start point parameters [m]

      x = coords(1)
      y = coords(2)
      z = coords(3)
      
C     FORM HEAT FLUX FROM SAMPLING POINTS
      if(JLTYP.EQ.0) then
      FLUX1=GFLUX(t,x,y)
      FLUX(1)=FLUX1
      FLUX(2)=0.0
      else if(JLTYP.EQ.11) then
      CC=5E-2
      FLUX(1)=-CC*(SOL-25.0)
      FLUX(2)=-CC
      else if(JLTYP.EQ.12) then
      CC=5E-2
      FLUX(1)=-CC*(SOL-25.0)
      FLUX(2)=-CC
      else if(JLTYP.GT.12) then
      CC=9E-4
      FLUX(1)=-CC*(SOL-25.0)
      FLUX(2)=-CC
      end if
      return
      end
            
      real function GFLUX(tau,x,y)
      IMPLICIT NONE
      real n,v,l
      real x,y,x0,y0,x1,y1
      real a,b
      real speed,Q,tau,pi
      
      x0 = 0.0
      y0 = 0.0
      x1 = 0.0
      y1 = 0.0
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! INCONEL 625   
!     VELOCITY OF WELDING / 10-15 (cm/minute) = 0.00166 [m/s] /0.0025[m/s]
!      100 (mm/minute) = 0.00166666667 m/s
!      200 (mm/minute) = 0.00333333333 m/s
!      400 (mm/minute) = 0.00666666667 m/s  
      speed = 0.0076e0
!      WRITE(6,*)'speed=',speed
! heat source efficiency
      n = 0.7e0   
!      WRITE(6,*)'n=',n
! voltage 8 - 9 V dla blachy 1 mm / 11 - 12 V dla blachy 2 mm
      v = 10e0
!      WRITE(6,*)'v=',v
! current [A] - 35 - 40[A] na mm
      l = 20e0
!      WRITE(6,*)'l=',l
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! energy
      Q = n*v*l
!      WRITE(6,*)'Q=',Q
!      WRITE(6,*)'tau=',tau
      x0=0.0e0
      y0=speed*tau
!      WRITE(6,*)'y0=',y0
      x1=x-x0
      y1=y-y0
!      WRITE(6,*)'y1=',y1
      
! size of welding arc [m]
      a = 0.0033e0
      b = 0.0033e0
      
!     PI
      pi=3.14159265359e0
       
!     FORM GOLDAK HEAT FLUX
     
      GFLUX=((3*Q)/(a*b*pi))*exp(-3e0*((x1/a)**2))*exp(-3e0*((y1/b)**2))
 !     GFLUX=Q*exp(-3e0*((x1/a)**2))*exp(-3e0*((y1/b)**2))
     
 !     WRITE(6,*)'GFLUX=',GFLUX
	  
      END